<dx-chart
id="chart"
[dataSource]="temperaturesData"
title="Daily Temperature in May"
[customizePoint]="customizePoint"
[customizeLabel]="customizeLabel"
>
<dxi-series
argumentField="day"
valueField="value"
type="bar"
color="#e7d19a"
></dxi-series>
<dxi-value-axis [maxValueMargin]="0.01" [visualRange]="{ startValue: 40 }">
<dxo-label [customizeText]="customizeText"></dxo-label>
<dxi-constant-line
[width]="2"
[value]="lowAverage"
color="#8c8cff"
dashStyle="dash"
>
<dxo-label text="Low Average"></dxo-label>
</dxi-constant-line>
<dxi-constant-line
[width]="2"
[value]="highAverage"
color="#ff7c7c"
dashStyle="dash"
>
<dxo-label text="High Average"></dxo-label>
</dxi-constant-line>
</dxi-value-axis>
<dxo-legend [visible]="false"></dxo-legend>
<dxo-export [enabled]="true"></dxo-export>
</dx-chart>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxChartModule } from 'devextreme-angular';
import { Service, Temperature } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
})
export class AppComponent {
highAverage = 77;
lowAverage = 58;
temperaturesData: Temperature[];
constructor(service: Service) {
this.temperaturesData = service.getTemperaturesData();
}
customizePoint = (arg: any) => {
if (arg.value > this.highAverage) {
return { color: '#ff7c7c', hoverStyle: { color: '#ff7c7c' } };
} if (arg.value < this.lowAverage) {
return { color: '#8c8cff', hoverStyle: { color: '#8c8cff' } };
}
};
customizeLabel = (arg: any) => {
if (arg.value > this.highAverage) {
return {
visible: true,
backgroundColor: '#ff7c7c',
customizeText(e: any) {
return `${e.valueText}°F`;
},
};
}
};
customizeText = (arg: any) => `${arg.valueText}°F`;
}
@NgModule({
imports: [
BrowserModule,
DxChartModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #chart {
height: 440px;
}
import { Injectable } from '@angular/core';
export class Temperature {
day: string;
value: number;
}
const temperaturesData : Temperature[] = [{
day: '1',
value: 57,
}, {
day: '2',
value: 58,
}, {
day: '3',
value: 57,
}, {
day: '4',
value: 59,
}, {
day: '5',
value: 63,
}, {
day: '6',
value: 63,
}, {
day: '7',
value: 63,
}, {
day: '8',
value: 64,
}, {
day: '9',
value: 64,
}, {
day: '10',
value: 64,
}, {
day: '11',
value: 69,
}, {
day: '12',
value: 72,
}, {
day: '13',
value: 75,
}, {
day: '14',
value: 78,
}, {
day: '15',
value: 76,
}, {
day: '16',
value: 70,
}, {
day: '17',
value: 65,
}, {
day: '18',
value: 65,
}, {
day: '19',
value: 68,
}, {
day: '20',
value: 70,
}, {
day: '21',
value: 73,
}, {
day: '22',
value: 73,
}, {
day: '23',
value: 75,
}, {
day: '24',
value: 78,
}, {
day: '25',
value: 76,
}, {
day: '26',
value: 76,
}, {
day: '27',
value: 80,
}, {
day: '28',
value: 76,
}, {
day: '29',
value: 75,
}, {
day: '30',
value: 75,
}, {
day: '31',
value: 74,
}];
@Injectable()
export class Service {
getTemperaturesData(): Temperature[] {
return temperaturesData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.17',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17',
'@angular/forms': 'npm:@angular/forms@12.2.17',
'@angular/common': 'npm:@angular/common@12.2.17',
'@angular/compiler': 'npm:@angular/compiler@12.2.17',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.6/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.2.6/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.72',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.43',
'devextreme-angular': 'npm:devextreme-angular@22.2.6',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.17/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.2.6/*/package.json',
'npm:devextreme-angular@22.2.6/ui/*/package.json',
'npm:devextreme-angular@22.2.6/package.json',
'npm:devexpress-diagram@2.1.72/package.json',
'npm:devexpress-gantt@4.1.43/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.6/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.13.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Your search did not match any results.
Bar Charts

Customize Points and Labels

This demo shows how you can customize individual points and labels in the Chart component.

Customize Points

Use the customizePoint function to change the appearance of individual series points. This function should return an object with properties that you want to change in a point configuration. This demo uses this function to color all points with values above the "High Average" in red, and points with values below the "Low Average" in blue.

Customize Labels

To customize the appearance of individual point labels, implement the customizeLabel function. This function should also return an object with properties that need to be changed for a certain label. This demo specifies custom labels for the red points.

Create Constant Lines

To create constant lines, follow the steps below:

  1. Choose a direction for the line. You can specify horizontal lines in the valueAxis object, and vertical - in the argumentAxis object.

  2. Specify the constantLines object. In this object, declare an object for each line with the properties you want to change.

Note that it's necessary to specify the value property for the line to display correctly.

Backend API
Copy to CodeSandBox
Apply
Reset
<template> <DxChart id="chart" :customize-point="customizePoint" :customize-label="customizeLabel" :data-source="dataSource" title="Daily Temperature in May" > <DxSeries argument-field="day" value-field="value" type="bar" color="#e7d19a" /> <DxValueAxis :max-value-margin="0.01"> <DxVisualRange :start-value="40"/> <DxLabel :customize-text="customizeText"/> <DxConstantLine :width="2" :value="lowAverage" color="#8c8cff" dash-style="dash" > <DxLabel text="Low Average"/> </DxConstantLine> <DxConstantLine :width="2" :value="highAverage" color="#ff7c7c" dash-style="dash" > <DxLabel text="High Average"/> </DxConstantLine> </DxValueAxis> <DxLegend :visible="false"/> <DxExport :enabled="true"/> </DxChart> </template> <script> import { DxChart, DxSeries, DxValueAxis, DxVisualRange, DxLabel, DxConstantLine, DxLegend, DxExport, } from 'devextreme-vue/chart'; import { temperaturesData } from './data.js'; export default { components: { DxChart, DxSeries, DxValueAxis, DxVisualRange, DxLabel, DxConstantLine, DxLegend, DxExport, }, data() { return { highAverage: 77, lowAverage: 58, dataSource: temperaturesData, }; }, methods: { customizePoint({ value }) { if (value > this.highAverage) { return { color: '#ff7c7c', hoverStyle: { color: '#ff7c7c' } }; } if (value < this.lowAverage) { return { color: '#8c8cff', hoverStyle: { color: '#8c8cff' } }; } return null; }, customizeLabel({ value }) { if (value > this.highAverage) { return { visible: true, backgroundColor: '#ff7c7c', customizeText({ valueText }) { return `${valueText}&#176F`; }, }; } return null; }, customizeText({ valueText }) { return `${valueText}&#176F`; }, }, }; </script> <style> #chart { height: 440px; } </style>
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.6/css/dx.light.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.js"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>
export const temperaturesData = [{ day: '1', value: 57, }, { day: '2', value: 58, }, { day: '3', value: 57, }, { day: '4', value: 59, }, { day: '5', value: 63, }, { day: '6', value: 63, }, { day: '7', value: 63, }, { day: '8', value: 64, }, { day: '9', value: 64, }, { day: '10', value: 64, }, { day: '11', value: 69, }, { day: '12', value: 72, }, { day: '13', value: 75, }, { day: '14', value: 78, }, { day: '15', value: 76, }, { day: '16', value: 70, }, { day: '17', value: 65, }, { day: '18', value: 65, }, { day: '19', value: 68, }, { day: '20', value: 70, }, { day: '21', value: 73, }, { day: '22', value: 73, }, { day: '23', value: 75, }, { day: '24', value: 78, }, { day: '25', value: 76, }, { day: '26', value: 76, }, { day: '27', value: 80, }, { day: '28', value: 76, }, { day: '29', value: 75, }, { day: '30', value: 75, }, { day: '31', value: 74, }];
window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, 'devextreme/localization.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, map: { 'vue': 'npm:vue@3.2.47/dist/vue.esm-browser.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@22.2.6/cjs', 'devextreme-vue': 'npm:devextreme-vue@22.2.6', 'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.1.72/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.43/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.11/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; System.config(window.config);

import React from 'react';
import {
Chart,
Series,
Legend,
ValueAxis,
VisualRange,
Label,
ConstantLine,
Export,
} from 'devextreme-react/chart';
import { temperaturesData } from './data.js';
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
highAverage: 77,
lowAverage: 58,
};
this.customizeLabel = this.customizeLabel.bind(this);
this.customizePoint = this.customizePoint.bind(this);
}
render() {
return (
<Chart
id="chart"
title="Daily Temperature in May"
dataSource={temperaturesData}
customizePoint={this.customizePoint}
customizeLabel={this.customizeLabel}
>
<Series
argumentField="day"
valueField="value"
type="bar"
color="#e7d19a"
/>
<ValueAxis maxValueMargin={0.01}>
<VisualRange startValue={40} />
<Label customizeText={this.customizeText} />
<ConstantLine
width={2}
value={this.state.lowAverage}
color="#8c8cff"
dashStyle="dash"
>
<Label text="Low Average" />
</ConstantLine>
<ConstantLine
width={2}
value={this.state.highAverage}
color="#ff7c7c"
dashStyle="dash"
>
<Label text="High Average" />
</ConstantLine>
</ValueAxis>
<Legend visible={false} />
<Export enabled={true} />
</Chart>
);
}
customizePoint(arg) {
if (arg.value > this.state.highAverage) {
return { color: '#ff7c7c', hoverStyle: { color: '#ff7c7c' } };
}
if (arg.value < this.state.lowAverage) {
return { color: '#8c8cff', hoverStyle: { color: '#8c8cff' } };
}
return null;
}
customizeLabel(arg) {
if (arg.value > this.state.highAverage) {
return {
visible: true,
backgroundColor: '#ff7c7c',
customizeText(e) {
return `${e.valueText}°F`;
},
};
}
return null;
}
customizeText(arg) {
return `${arg.valueText}°F`;
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart {
height: 440px;
}
export const temperaturesData = [{
day: '1',
value: 57,
}, {
day: '2',
value: 58,
}, {
day: '3',
value: 57,
}, {
day: '4',
value: 59,
}, {
day: '5',
value: 63,
}, {
day: '6',
value: 63,
}, {
day: '7',
value: 63,
}, {
day: '8',
value: 64,
}, {
day: '9',
value: 64,
}, {
day: '10',
value: 64,
}, {
day: '11',
value: 69,
}, {
day: '12',
value: 72,
}, {
day: '13',
value: 75,
}, {
day: '14',
value: 78,
}, {
day: '15',
value: 76,
}, {
day: '16',
value: 70,
}, {
day: '17',
value: 65,
}, {
day: '18',
value: 65,
}, {
day: '19',
value: 68,
}, {
day: '20',
value: 70,
}, {
day: '21',
value: 73,
}, {
day: '22',
value: 73,
}, {
day: '23',
value: 75,
}, {
day: '24',
value: 78,
}, {
day: '25',
value: 76,
}, {
day: '26',
value: 76,
}, {
day: '27',
value: 80,
}, {
day: '28',
value: 76,
}, {
day: '29',
value: 75,
}, {
day: '30',
value: 75,
}, {
day: '31',
value: 74,
}];
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.6/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.6',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.72/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.43/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);